import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsComment, GoodsCommentParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询评论表
 */
export async function pageGoodsComment(params: GoodsCommentParam) {
  const res = await request.get<ApiResult<PageResult<GoodsComment>>>(
    MODULES_API_URL + '/shop/goods-comment/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询评论表列表
 */
export async function listGoodsComment(params?: GoodsCommentParam) {
  const res = await request.get<ApiResult<GoodsComment[]>>(
    MODULES_API_URL + '/shop/goods-comment',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加评论表
 */
export async function addGoodsComment(data: GoodsComment) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-comment',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改评论表
 */
export async function updateGoodsComment(data: GoodsComment) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-comment',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除评论表
 */
export async function removeGoodsComment(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-comment/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除评论表
 */
export async function removeBatchGoodsComment(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-comment/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询评论表
 */
export async function getGoodsComment(id: number) {
  const res = await request.get<ApiResult<GoodsComment>>(
    MODULES_API_URL + '/shop/goods-comment/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
